=== modified file 'Makefile'
--- Makefile	2010-10-02 17:23:41 +0000
+++ Makefile	2010-10-11 17:45:21 +0000
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.2.1
+version=1.2.3
 SED=sed
 
 ## Use these settings for a traditional /usr/local install

=== modified file 'NEWS'
--- NEWS	2010-10-02 17:23:41 +0000
+++ NEWS	2010-10-11 17:45:21 +0000
@@ -1,6 +1,14 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
+Version 1.2.3 (2010-10-11)
+* Server:
+** Bug fix: Expose D-Bus API also in non-debug mode.
+
+Version 1.2.2 (2010-10-07)
+* Client:
+** splashy: Minor fix to compile with non-Linux kernels.
+
 Version 1.2.1 (2010-10-02)
 * Server:
 ** mandos-monitor(8): Documentation bug fix: Key for removing client

=== modified file 'TODO'
--- TODO	2010-09-26 18:32:58 +0000
+++ TODO	2010-11-16 17:58:49 +0000
@@ -2,6 +2,8 @@
 
 * Use _attribute_((nonnull)) wherever possible.
 
+* mandos-applet
+
 * mandos-client
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name

=== modified file 'common.ent'
--- common.ent	2010-10-02 17:23:41 +0000
+++ common.ent	2010-10-11 17:45:21 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.2.1">
+<!ENTITY version "1.2.3">

=== modified file 'debian/changelog'
--- debian/changelog	2010-10-05 19:03:43 +0000
+++ debian/changelog	2010-10-11 17:45:21 +0000
@@ -1,3 +1,16 @@
+mandos (1.2.3-1) experimental; urgency=low
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Mon, 11 Oct 2010 19:37:31 +0200
+
+mandos (1.2.2-1) experimental; urgency=low
+
+  * New upstream release.
+  * plugins.d/splashy.c: Only use ELIBBAD if defined. (Closes: #599256)
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Thu, 07 Oct 2010 20:27:54 +0200
+
 mandos (1.2.1-3) experimental; urgency=low
 
   * debian/changelog: Include entry for NMU of version 1.0.14-1.1.

=== modified file 'debian/mandos-client.lintian-overrides'
--- debian/mandos-client.lintian-overrides	2009-01-18 06:41:57 +0000
+++ debian/mandos-client.lintian-overrides	2010-10-13 06:12:52 +0000
@@ -19,6 +19,7 @@
 mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/askpass-fifo 4755 root/root
 mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/splashy 4755 root/root
 mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/usplash 4755 root/root
+mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/plymouth 4755 root/root
 
 # The directory /etc/mandos/plugins.d can be used by local system
 # administrators to place plugins in, overriding and complementing

=== modified file 'mandos'
--- mandos	2010-10-02 17:23:41 +0000
+++ mandos	2011-02-11 19:36:42 +0000
@@ -81,13 +81,13 @@
         SO_BINDTODEVICE = None
 
 
-version = "1.2.1"
+version = u"1.2.3"
 
 #logger = logging.getLogger(u'mandos')
 logger = logging.Logger(u'mandos')
 syslogger = (logging.handlers.SysLogHandler
              (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
-              address = "/dev/log"))
+              address = u"/dev/log"))
 syslogger.setFormatter(logging.Formatter
                        (u'Mandos [%(process)d]: %(levelname)s:'
                         u' %(message)s'))
@@ -204,7 +204,7 @@
         if state == avahi.ENTRY_GROUP_ESTABLISHED:
             logger.debug(u"Zeroconf service established.")
         elif state == avahi.ENTRY_GROUP_COLLISION:
-            logger.warning(u"Zeroconf service name collision.")
+            logger.info(u"Zeroconf service name collision.")
             self.rename()
         elif state == avahi.ENTRY_GROUP_FAILURE:
             logger.critical(u"Avahi: Error in group state changed %s",
@@ -314,7 +314,7 @@
         elif u"secfile" in config:
             with open(os.path.expanduser(os.path.expandvars
                                          (config[u"secfile"])),
-                      "rb") as secfile:
+                      u"rb") as secfile:
                 self.secret = secfile.read()
         else:
             raise TypeError(u"No secret or secfile for client %s"
@@ -372,7 +372,7 @@
     
     def disable(self, quiet=True):
         """Disable this client."""
-        if not getattr(self, "enabled", False):
+        if not getattr(self, u"enabled", False):
             return False
         if not quiet:
             self.send_changedstate()
@@ -663,8 +663,8 @@
     
     @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
                          out_signature=u"s",
-                         path_keyword='object_path',
-                         connection_keyword='connection')
+                         path_keyword=u'object_path',
+                         connection_keyword=u'connection')
     def Introspect(self, object_path, connection):
         """Standard D-Bus method, overloaded to insert property tags.
         """
@@ -742,7 +742,7 @@
         old_value = self._approvals_pending
         self._approvals_pending = value
         bval = bool(value)
-        if (hasattr(self, "dbus_object_path")
+        if (hasattr(self, u"dbus_object_path")
             and bval is not bool(old_value)):
             dbus_bool = dbus.Boolean(bval, variant_level=1)
             self.PropertyChanged(dbus.String(u"ApprovalPending"),
@@ -1138,27 +1138,27 @@
 class ProxyClient(object):
     def __init__(self, child_pipe, fpr, address):
         self._pipe = child_pipe
-        self._pipe.send(('init', fpr, address))
+        self._pipe.send((u'init', fpr, address))
         if not self._pipe.recv():
             raise KeyError()
 
     def __getattribute__(self, name):
-        if(name == '_pipe'):
+        if(name == u'_pipe'):
             return super(ProxyClient, self).__getattribute__(name)
-        self._pipe.send(('getattr', name))
+        self._pipe.send((u'getattr', name))
         data = self._pipe.recv()
-        if data[0] == 'data':
+        if data[0] == u'data':
             return data[1]
-        if data[0] == 'function':
+        if data[0] == u'function':
             def func(*args, **kwargs):
-                self._pipe.send(('funcall', name, args, kwargs))
+                self._pipe.send((u'funcall', name, args, kwargs))
                 return self._pipe.recv()[1]
             return func
 
     def __setattr__(self, name, value):
-        if(name == '_pipe'):
+        if(name == u'_pipe'):
             return super(ProxyClient, self).__setattr__(name, value)
-        self._pipe.send(('setattr', name, value))
+        self._pipe.send((u'setattr', name, value))
 
 
 class ClientHandler(socketserver.BaseRequestHandler, object):
@@ -1244,7 +1244,7 @@
                                        client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
-                            client.Rejected("Disabled")                    
+                            client.Rejected(u"Disabled")                    
                         return
                     
                     if client._approved or not client.approval_delay:
@@ -1263,7 +1263,7 @@
                                        client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
-                            client.Rejected("Denied")
+                            client.Rejected(u"Denied")
                         return
                     
                     #wait until timeout or approved
@@ -1275,12 +1275,12 @@
                     time2 = datetime.datetime.now()
                     if (time2 - time) >= delay:
                         if not client.approved_by_default:
-                            logger.warning("Client %s timed out while"
-                                           " waiting for approval",
+                            logger.warning(u"Client %s timed out while"
+                                           u" waiting for approval",
                                            client.name)
                             if self.server.use_dbus:
                                 # Emit D-Bus signal
-                                client.Rejected("Approval timed out")
+                                client.Rejected(u"Approval timed out")
                             return
                         else:
                             break
@@ -1292,7 +1292,7 @@
                     try:
                         sent = session.send(client.secret[sent_size:])
                     except (gnutls.errors.GNUTLSError), error:
-                        logger.warning("gnutls send failed")
+                        logger.warning(u"gnutls send failed")
                         return
                     logger.debug(u"Sent: %d, remaining: %d",
                                  sent, len(client.secret)
@@ -1312,7 +1312,7 @@
                 try:
                     session.bye()
                 except (gnutls.errors.GNUTLSError), error:
-                    logger.warning("GnuTLS bye failed")
+                    logger.warning(u"GnuTLS bye failed")
     
     @staticmethod
     def peer_certificate(session):
@@ -1520,7 +1520,7 @@
                                     # broken, usually for pipes and
                                     # sockets).
             }
-        conditions_string = ' | '.join(name
+        conditions_string = u' | '.join(name
                                        for cond, name in
                                        condition_names.iteritems()
                                        if cond & condition)
@@ -1532,7 +1532,7 @@
         request = parent_pipe.recv()
         command = request[0]
         
-        if command == 'init':
+        if command == u'init':
             fpr = request[1]
             address = request[2]
             
@@ -1557,21 +1557,21 @@
             parent_pipe.send(True)
             # remove the old hook in favor of the new above hook on same fileno
             return False
-        if command == 'funcall':
+        if command == u'funcall':
             funcname = request[1]
             args = request[2]
             kwargs = request[3]
             
-            parent_pipe.send(('data', getattr(client_object, funcname)(*args, **kwargs)))
+            parent_pipe.send((u'data', getattr(client_object, funcname)(*args, **kwargs)))
 
-        if command == 'getattr':
+        if command == u'getattr':
             attrname = request[1]
             if callable(client_object.__getattribute__(attrname)):
-                parent_pipe.send(('function',))
+                parent_pipe.send((u'function',))
             else:
-                parent_pipe.send(('data', client_object.__getattribute__(attrname)))
+                parent_pipe.send((u'data', client_object.__getattribute__(attrname)))
         
-        if command == 'setattr':
+        if command == u'setattr':
             attrname = request[1]
             value = request[2]
             setattr(client_object, attrname, value)
@@ -1672,32 +1672,32 @@
     ##################################################################
     # Parsing of options, both command line and config file
     
-    parser = optparse.OptionParser(version = "%%prog %s" % version)
-    parser.add_option("-i", u"--interface", type=u"string",
-                      metavar="IF", help=u"Bind to interface IF")
-    parser.add_option("-a", u"--address", type=u"string",
+    parser = optparse.OptionParser(version = u"%%prog %s" % version)
+    parser.add_option(u"-i", u"--interface", type=u"string",
+                      metavar=u"IF", help=u"Bind to interface IF")
+    parser.add_option(u"-a", u"--address", type=u"string",
                       help=u"Address to listen for requests on")
-    parser.add_option("-p", u"--port", type=u"int",
+    parser.add_option(u"-p", u"--port", type=u"int",
                       help=u"Port number to receive requests on")
-    parser.add_option("--check", action=u"store_true",
+    parser.add_option(u"--check", action=u"store_true",
                       help=u"Run self-test")
-    parser.add_option("--debug", action=u"store_true",
+    parser.add_option(u"--debug", action=u"store_true",
                       help=u"Debug mode; run in foreground and log to"
                       u" terminal")
-    parser.add_option("--debuglevel", type=u"string", metavar="LEVEL",
+    parser.add_option(u"--debuglevel", type=u"string", metavar="LEVEL",
                       help=u"Debug level for stdout output")
-    parser.add_option("--priority", type=u"string", help=u"GnuTLS"
+    parser.add_option(u"--priority", type=u"string", help=u"GnuTLS"
                       u" priority string (see GnuTLS documentation)")
-    parser.add_option("--servicename", type=u"string",
+    parser.add_option(u"--servicename", type=u"string",
                       metavar=u"NAME", help=u"Zeroconf service name")
-    parser.add_option("--configdir", type=u"string",
+    parser.add_option(u"--configdir", type=u"string",
                       default=u"/etc/mandos", metavar=u"DIR",
                       help=u"Directory to search for configuration"
                       u" files")
-    parser.add_option("--no-dbus", action=u"store_false",
+    parser.add_option(u"--no-dbus", action=u"store_false",
                       dest=u"use_dbus", help=u"Do not provide D-Bus"
                       u" system bus interface")
-    parser.add_option("--no-ipv6", action=u"store_false",
+    parser.add_option(u"--no-ipv6", action=u"store_false",
                       dest=u"use_ipv6", help=u"Do not use IPv6")
     options = parser.parse_args()[0]
     
@@ -1730,8 +1730,8 @@
     for option in (u"debug", u"use_dbus", u"use_ipv6"):
         server_settings[option] = server_config.getboolean(u"DEFAULT",
                                                            option)
-    if server_settings["port"]:
-        server_settings["port"] = server_config.getint(u"DEFAULT",
+    if server_settings[u"port"]:
+        server_settings[u"port"] = server_config.getint(u"DEFAULT",
                                                        u"port")
     del server_config
     
@@ -1847,6 +1847,10 @@
         # No console logging
         logger.removeHandler(console)
     
+    # Need to fork before connecting to D-Bus
+    if not debug:
+        # Close all input and output, do double fork, etc.
+        daemon()
     
     global main_loop
     # From the Avahi example code
@@ -1867,14 +1871,10 @@
     service = AvahiService(name = server_settings[u"servicename"],
                            servicetype = u"_mandos._tcp",
                            protocol = protocol, bus = bus)
-    if server_settings["interface"]:
+    if server_settings[u"interface"]:
         service.interface = (if_nametoindex
                              (str(server_settings[u"interface"])))
-
-    if not debug:
-        # Close all input and output, do double fork, etc.
-        daemon()
-        
+    
     global multiprocessing_manager
     multiprocessing_manager = multiprocessing.Manager()
     
@@ -1883,9 +1883,9 @@
         client_class = functools.partial(ClientDBus, bus = bus)
     def client_config_items(config, section):
         special_settings = {
-            "approved_by_default":
+            u"approved_by_default":
                 lambda: config.getboolean(section,
-                                          "approved_by_default"),
+                                          u"approved_by_default"),
             }
         for name, value in config.items(section):
             try:
@@ -1905,7 +1905,7 @@
         try:
             with pidfile:
                 pid = os.getpid()
-                pidfile.write(str(pid) + "\n")
+                pidfile.write(str(pid) + u"\n".encode("utf-8"))
             del pidfile
         except IOError:
             logger.error(u"Could not write to file %r with PID %d",
@@ -2006,7 +2006,7 @@
     service.port = tcp_server.socket.getsockname()[1]
     if use_ipv6:
         logger.info(u"Now listening on address %r, port %d,"
-                    " flowinfo %d, scope_id %d"
+                    u" flowinfo %d, scope_id %d"
                     % tcp_server.socket.getsockname())
     else:                       # IPv4
         logger.info(u"Now listening on address %r, port %d"
@@ -2043,5 +2043,5 @@
     # Must run before the D-Bus bus name gets deregistered
     cleanup()
 
-if __name__ == '__main__':
+if __name__ == u'__main__':
     main()

=== modified file 'mandos-ctl'
--- mandos-ctl	2010-10-02 17:23:41 +0000
+++ mandos-ctl	2010-10-11 17:45:21 +0000
@@ -57,7 +57,7 @@
 server_path = '/'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.2.1"
+version = "1.2.3"
 
 def timedelta_to_milliseconds(td):
     "Convert a datetime.timedelta object to milliseconds"

=== modified file 'mandos-keygen'
--- mandos-keygen	2010-10-02 17:23:41 +0000
+++ mandos-keygen	2010-10-11 17:45:21 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-VERSION="1.2.1"
+VERSION="1.2.3"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos-monitor'
--- mandos-monitor	2010-10-02 17:23:41 +0000
+++ mandos-monitor	2011-02-11 19:02:24 +0000
@@ -22,7 +22,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-from __future__ import division, absolute_import, with_statement
+from __future__ import division, absolute_import, print_function, unicode_literals
 
 import sys
 import os
@@ -42,7 +42,7 @@
 
 import locale
 
-locale.setlocale(locale.LC_ALL, u'')
+locale.setlocale(locale.LC_ALL, '')
 
 import logging
 logging.getLogger('dbus.proxies').setLevel(logging.CRITICAL)
@@ -51,7 +51,7 @@
 domain = 'se.bsnet.fukt'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.2.1"
+version = "1.2.3"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False
@@ -65,9 +65,9 @@
     "Parse an ISO 8601 date string to a datetime.datetime()"
     if not iso:
         return None
-    d, t = iso.split(u"T", 1)
-    year, month, day = d.split(u"-", 2)
-    hour, minute, second = t.split(u":", 2)
+    d, t = iso.split("T", 1)
+    year, month, day = d.split("-", 2)
+    hour, minute, second = t.split(":", 2)
     second, fraction = divmod(float(second), 1)
     return datetime.datetime(int(year),
                              int(month),
@@ -86,7 +86,7 @@
         self.proxy = proxy_object # Mandos Client proxy object
         
         self.properties = dict()
-        self.proxy.connect_to_signal(u"PropertyChanged",
+        self.proxy.connect_to_signal("PropertyChanged",
                                      self.property_changed,
                                      client_interface,
                                      byte_arrays=True)
@@ -127,9 +127,9 @@
         self.last_checker_failed = False
         
         # The widget shown normally
-        self._text_widget = urwid.Text(u"")
+        self._text_widget = urwid.Text("")
         # The widget shown when we have focus
-        self._focus_text_widget = urwid.Text(u"")
+        self._focus_text_widget = urwid.Text("")
         super(MandosClientWidget, self).__init__(
             update_hook=update_hook, delete_hook=delete_hook,
             *args, **kwargs)
@@ -137,7 +137,7 @@
         self.opened = False
         
         last_checked_ok = isoformat_to_datetime(self.properties
-                                                [u"LastCheckedOK"])
+                                                ["LastCheckedOK"])
         if last_checked_ok is None:
             self.last_checker_failed = True
         else:
@@ -146,7 +146,7 @@
                                         > datetime.timedelta
                                         (milliseconds=
                                          self.properties
-                                         [u"Interval"]))
+                                         ["Interval"]))
         
         if self.last_checker_failed:
             self.using_timer(True)
@@ -154,23 +154,23 @@
         if self.need_approval:
             self.using_timer(True)
         
-        self.proxy.connect_to_signal(u"CheckerCompleted",
+        self.proxy.connect_to_signal("CheckerCompleted",
                                      self.checker_completed,
                                      client_interface,
                                      byte_arrays=True)
-        self.proxy.connect_to_signal(u"CheckerStarted",
+        self.proxy.connect_to_signal("CheckerStarted",
                                      self.checker_started,
                                      client_interface,
                                      byte_arrays=True)
-        self.proxy.connect_to_signal(u"GotSecret",
+        self.proxy.connect_to_signal("GotSecret",
                                      self.got_secret,
                                      client_interface,
                                      byte_arrays=True)
-        self.proxy.connect_to_signal(u"NeedApproval",
+        self.proxy.connect_to_signal("NeedApproval",
                                      self.need_approval,
                                      client_interface,
                                      byte_arrays=True)
-        self.proxy.connect_to_signal(u"Rejected",
+        self.proxy.connect_to_signal("Rejected",
                                      self.rejected,
                                      client_interface,
                                      byte_arrays=True)
@@ -178,7 +178,7 @@
     def property_changed(self, property=None, value=None):
         super(self, MandosClientWidget).property_changed(property,
                                                          value)
-        if property == u"ApprovalPending":
+        if property == "ApprovalPending":
             using_timer(bool(value))
         
     def using_timer(self, flag):
@@ -203,9 +203,9 @@
             if self.last_checker_failed:
                 self.last_checker_failed = False
                 self.using_timer(False)
-            #self.logger(u'Checker for client %s (command "%s")'
-            #            u' was successful'
-            #            % (self.properties[u"Name"], command))
+            #self.logger('Checker for client %s (command "%s")'
+            #            ' was successful'
+            #            % (self.properties["Name"], command))
             self.update()
             return
         # Checker failed
@@ -213,57 +213,57 @@
             self.last_checker_failed = True
             self.using_timer(True)
         if os.WIFEXITED(condition):
-            self.logger(u'Checker for client %s (command "%s")'
-                        u' failed with exit code %s'
-                        % (self.properties[u"Name"], command,
+            self.logger('Checker for client %s (command "%s")'
+                        ' failed with exit code %s'
+                        % (self.properties["Name"], command,
                            os.WEXITSTATUS(condition)))
         elif os.WIFSIGNALED(condition):
-            self.logger(u'Checker for client %s (command "%s")'
-                        u' was killed by signal %s'
-                        % (self.properties[u"Name"], command,
+            self.logger('Checker for client %s (command "%s")'
+                        ' was killed by signal %s'
+                        % (self.properties["Name"], command,
                            os.WTERMSIG(condition)))
         elif os.WCOREDUMP(condition):
-            self.logger(u'Checker for client %s (command "%s")'
-                        u' dumped core'
-                        % (self.properties[u"Name"], command))
+            self.logger('Checker for client %s (command "%s")'
+                        ' dumped core'
+                        % (self.properties["Name"], command))
         else:
-            self.logger(u'Checker for client %s completed'
-                        u' mysteriously')
+            self.logger('Checker for client %s completed'
+                        ' mysteriously')
         self.update()
     
     def checker_started(self, command):
-        #self.logger(u'Client %s started checker "%s"'
-        #            % (self.properties[u"Name"], unicode(command)))
+        #self.logger('Client %s started checker "%s"'
+        #            % (self.properties["Name"], unicode(command)))
         pass
     
     def got_secret(self):
         self.last_checker_failed = False
-        self.logger(u'Client %s received its secret'
-                    % self.properties[u"Name"])
+        self.logger('Client %s received its secret'
+                    % self.properties["Name"])
     
     def need_approval(self, timeout, default):
         if not default:
-            message = u'Client %s needs approval within %s seconds'
+            message = 'Client %s needs approval within %s seconds'
         else:
-            message = u'Client %s will get its secret in %s seconds'
+            message = 'Client %s will get its secret in %s seconds'
         self.logger(message
-                    % (self.properties[u"Name"], timeout/1000))
+                    % (self.properties["Name"], timeout/1000))
         self.using_timer(True)
     
     def rejected(self, reason):
-        self.logger(u'Client %s was rejected; reason: %s'
-                    % (self.properties[u"Name"], reason))
+        self.logger('Client %s was rejected; reason: %s'
+                    % (self.properties["Name"], reason))
     
     def selectable(self):
         """Make this a "selectable" widget.
         This overrides the method from urwid.FlowWidget."""
         return True
     
-    def rows(self, (maxcol,), focus=False):
+    def rows(self, maxcolrow, focus=False):
         """How many rows this widget will occupy might depend on
         whether we have focus or not.
         This overrides the method from urwid.FlowWidget"""
-        return self.current_widget(focus).rows((maxcol,), focus=focus)
+        return self.current_widget(focus).rows(maxcolrow, focus=focus)
     
     def current_widget(self, focus=False):
         if focus or self.opened:
@@ -273,56 +273,56 @@
     def update(self):
         "Called when what is visible on the screen should be updated."
         # How to add standout mode to a style
-        with_standout = { u"normal": u"standout",
-                          u"bold": u"bold-standout",
-                          u"underline-blink":
-                              u"underline-blink-standout",
-                          u"bold-underline-blink":
-                              u"bold-underline-blink-standout",
+        with_standout = { "normal": "standout",
+                          "bold": "bold-standout",
+                          "underline-blink":
+                              "underline-blink-standout",
+                          "bold-underline-blink":
+                              "bold-underline-blink-standout",
                           }
 
         # Rebuild focus and non-focus widgets using current properties
 
         # Base part of a client. Name!
-        base = (u'%(name)s: '
-                      % {u"name": self.properties[u"Name"]})
-        if not self.properties[u"Enabled"]:
-            message = u"DISABLED"
-        elif self.properties[u"ApprovalPending"]:
+        base = ('%(name)s: '
+                      % {"name": self.properties["Name"]})
+        if not self.properties["Enabled"]:
+            message = "DISABLED"
+        elif self.properties["ApprovalPending"]:
             timeout = datetime.timedelta(milliseconds
                                          = self.properties
-                                         [u"ApprovalDelay"])
+                                         ["ApprovalDelay"])
             last_approval_request = isoformat_to_datetime(
-                self.properties[u"LastApprovalRequest"])
+                self.properties["LastApprovalRequest"])
             if last_approval_request is not None:
                 timer = timeout - (datetime.datetime.utcnow()
                                    - last_approval_request)
             else:
                 timer = datetime.timedelta()
-            if self.properties[u"ApprovedByDefault"]:
-                message = u"Approval in %s. (d)eny?"
+            if self.properties["ApprovedByDefault"]:
+                message = "Approval in %s. (d)eny?"
             else:
-                message = u"Denial in %s. (a)pprove?"
+                message = "Denial in %s. (a)pprove?"
             message = message % unicode(timer).rsplit(".", 1)[0]
         elif self.last_checker_failed:
             timeout = datetime.timedelta(milliseconds
                                          = self.properties
-                                         [u"Timeout"])
+                                         ["Timeout"])
             last_ok = isoformat_to_datetime(
-                max((self.properties[u"LastCheckedOK"]
-                     or self.properties[u"Created"]),
-                    self.properties[u"LastEnabled"]))
+                max((self.properties["LastCheckedOK"]
+                     or self.properties["Created"]),
+                    self.properties["LastEnabled"]))
             timer = timeout - (datetime.datetime.utcnow() - last_ok)
-            message = (u'A checker has failed! Time until client'
-                       u' gets disabled: %s'
+            message = ('A checker has failed! Time until client'
+                       ' gets disabled: %s'
                            % unicode(timer).rsplit(".", 1)[0])
         else:
-            message = u"enabled"
+            message = "enabled"
         self._text = "%s%s" % (base, message)
             
         if not urwid.supports_unicode():
             self._text = self._text.encode("ascii", "replace")
-        textlist = [(u"normal", self._text)]
+        textlist = [("normal", self._text)]
         self._text_widget.set_text(textlist)
         self._focus_text_widget.set_text([(with_standout[text[0]],
                                            text[1])
@@ -348,40 +348,40 @@
         if self.delete_hook is not None:
             self.delete_hook(self)
     
-    def render(self, (maxcol,), focus=False):
+    def render(self, maxcolrow, focus=False):
         """Render differently if we have focus.
         This overrides the method from urwid.FlowWidget"""
-        return self.current_widget(focus).render((maxcol,),
+        return self.current_widget(focus).render(maxcolrow,
                                                  focus=focus)
     
-    def keypress(self, (maxcol,), key):
+    def keypress(self, maxcolrow, key):
         """Handle keys.
         This overrides the method from urwid.FlowWidget"""
-        if key == u"+":
+        if key == "+":
             self.proxy.Enable(dbus_interface = client_interface)
-        elif key == u"-":
+        elif key == "-":
             self.proxy.Disable(dbus_interface = client_interface)
-        elif key == u"a":
+        elif key == "a":
             self.proxy.Approve(dbus.Boolean(True, variant_level=1),
                                dbus_interface = client_interface)
-        elif key == u"d":
+        elif key == "d":
             self.proxy.Approve(dbus.Boolean(False, variant_level=1),
                                   dbus_interface = client_interface)
-        elif key == u"R" or key == u"_" or key == u"ctrl k":
+        elif key == "R" or key == "_" or key == "ctrl k":
             self.server_proxy_object.RemoveClient(self.proxy
                                                   .object_path)
-        elif key == u"s":
+        elif key == "s":
             self.proxy.StartChecker(dbus_interface = client_interface)
-        elif key == u"S":
+        elif key == "S":
             self.proxy.StopChecker(dbus_interface = client_interface)
-        elif key == u"C":
+        elif key == "C":
             self.proxy.CheckedOK(dbus_interface = client_interface)
         # xxx
-#         elif key == u"p" or key == "=":
+#         elif key == "p" or key == "=":
 #             self.proxy.pause()
-#         elif key == u"u" or key == ":":
+#         elif key == "u" or key == ":":
 #             self.proxy.unpause()
-#         elif key == u"RET":
+#         elif key == "RET":
 #             self.open()
         else:
             return key
@@ -403,10 +403,9 @@
     "down" key presses, thus not allowing any containing widgets to
     use them as an excuse to shift focus away from this widget.
     """
-    def keypress(self, (maxcol, maxrow), key):
-        ret = super(ConstrainedListBox, self).keypress((maxcol,
-                                                        maxrow), key)
-        if ret in (u"up", u"down"):
+    def keypress(self, maxcolrow, key):
+        ret = super(ConstrainedListBox, self).keypress(maxcolrow, key)
+        if ret in ("up", "down"):
             return
         return ret
 
@@ -421,31 +420,31 @@
         self.screen = urwid.curses_display.Screen()
         
         self.screen.register_palette((
-                (u"normal",
-                 u"default", u"default", None),
-                (u"bold",
-                 u"default", u"default", u"bold"),
-                (u"underline-blink",
-                 u"default", u"default", u"underline"),
-                (u"standout",
-                 u"default", u"default", u"standout"),
-                (u"bold-underline-blink",
-                 u"default", u"default", (u"bold", u"underline")),
-                (u"bold-standout",
-                 u"default", u"default", (u"bold", u"standout")),
-                (u"underline-blink-standout",
-                 u"default", u"default", (u"underline", u"standout")),
-                (u"bold-underline-blink-standout",
-                 u"default", u"default", (u"bold", u"underline",
-                                          u"standout")),
+                ("normal",
+                 "default", "default", None),
+                ("bold",
+                 "default", "default", "bold"),
+                ("underline-blink",
+                 "default", "default", "underline"),
+                ("standout",
+                 "default", "default", "standout"),
+                ("bold-underline-blink",
+                 "default", "default", ("bold", "underline")),
+                ("bold-standout",
+                 "default", "default", ("bold", "standout")),
+                ("underline-blink-standout",
+                 "default", "default", ("underline", "standout")),
+                ("bold-underline-blink-standout",
+                 "default", "default", ("bold", "underline",
+                                          "standout")),
                 ))
         
         if urwid.supports_unicode():
-            self.divider = u"─" # \u2500
-            #self.divider = u"━" # \u2501
+            self.divider = "─" # \u2500
+            #self.divider = "━" # \u2501
         else:
-            #self.divider = u"-" # \u002d
-            self.divider = u"_" # \u005f
+            #self.divider = "-" # \u002d
+            self.divider = "_" # \u005f
         
         self.screen.start()
         
@@ -465,19 +464,19 @@
         # This keeps track of whether self.uilist currently has
         # self.logbox in it or not
         self.log_visible = True
-        self.log_wrap = u"any"
+        self.log_wrap = "any"
         
         self.rebuild()
-        self.log_message_raw((u"bold",
-                              u"Mandos Monitor version " + version))
-        self.log_message_raw((u"bold",
-                              u"q: Quit  ?: Help"))
+        self.log_message_raw(("bold",
+                              "Mandos Monitor version " + version))
+        self.log_message_raw(("bold",
+                              "q: Quit  ?: Help"))
         
         self.busname = domain + '.Mandos'
         self.main_loop = gobject.MainLoop()
         self.bus = dbus.SystemBus()
         mandos_dbus_objc = self.bus.get_object(
-            self.busname, u"/", follow_name_owner_changes=True)
+            self.busname, "/", follow_name_owner_changes=True)
         self.mandos_serv = dbus.Interface(mandos_dbus_objc,
                                           dbus_interface
                                           = server_interface)
@@ -488,17 +487,17 @@
             mandos_clients = dbus.Dictionary()
         
         (self.mandos_serv
-         .connect_to_signal(u"ClientRemoved",
+         .connect_to_signal("ClientRemoved",
                             self.find_and_remove_client,
                             dbus_interface=server_interface,
                             byte_arrays=True))
         (self.mandos_serv
-         .connect_to_signal(u"ClientAdded",
+         .connect_to_signal("ClientAdded",
                             self.add_new_client,
                             dbus_interface=server_interface,
                             byte_arrays=True))
         (self.mandos_serv
-         .connect_to_signal(u"ClientNotFound",
+         .connect_to_signal("ClientNotFound",
                             self.client_not_found,
                             dbus_interface=server_interface,
                             byte_arrays=True))
@@ -519,8 +518,8 @@
                             path=path)
     
     def client_not_found(self, fingerprint, address):
-        self.log_message((u"Client with address %s and fingerprint %s"
-                          u" could not be found" % (address,
+        self.log_message(("Client with address %s and fingerprint %s"
+                          " could not be found" % (address,
                                                     fingerprint)))
     
     def rebuild(self):
@@ -542,7 +541,7 @@
     
     def log_message(self, message):
         timestamp = datetime.datetime.now().isoformat()
-        self.log_message_raw(timestamp + u": " + message)
+        self.log_message_raw(timestamp + ": " + message)
     
     def log_message_raw(self, markup):
         """Add a log message to the log buffer."""
@@ -551,26 +550,26 @@
             and len(self.log) > self.max_log_length):
             del self.log[0:len(self.log)-self.max_log_length-1]
         self.logbox.set_focus(len(self.logbox.body.contents),
-                              coming_from=u"above")
+                              coming_from="above")
         self.refresh()
     
     def toggle_log_display(self):
         """Toggle visibility of the log buffer."""
         self.log_visible = not self.log_visible
         self.rebuild()
-        #self.log_message(u"Log visibility changed to: "
+        #self.log_message("Log visibility changed to: "
         #                 + unicode(self.log_visible))
     
     def change_log_display(self):
         """Change type of log display.
         Currently, this toggles wrapping of text lines."""
-        if self.log_wrap == u"clip":
-            self.log_wrap = u"any"
+        if self.log_wrap == "clip":
+            self.log_wrap = "any"
         else:
-            self.log_wrap = u"clip"
+            self.log_wrap = "clip"
         for textwidget in self.log:
             textwidget.set_wrap_mode(self.log_wrap)
-        #self.log_message(u"Wrap mode: " + self.log_wrap)
+        #self.log_message("Wrap mode: " + self.log_wrap)
     
     def find_and_remove_client(self, path, name):
         """Find an client from its object path and remove it.
@@ -603,7 +602,7 @@
         if path is None:
             path = client.proxy.object_path
         self.clients_dict[path] = client
-        self.clients.sort(None, lambda c: c.properties[u"Name"])
+        self.clients.sort(None, lambda c: c.properties["Name"])
         self.refresh()
     
     def remove_client(self, client, path=None):
@@ -640,15 +639,15 @@
     
     def process_input(self, source, condition):
         keys = self.screen.get_input()
-        translations = { u"ctrl n": u"down",      # Emacs
-                         u"ctrl p": u"up",        # Emacs
-                         u"ctrl v": u"page down", # Emacs
-                         u"meta v": u"page up",   # Emacs
-                         u" ": u"page down",      # less
-                         u"f": u"page down",      # less
-                         u"b": u"page up",        # less
-                         u"j": u"down",           # vi
-                         u"k": u"up",             # vi
+        translations = { "ctrl n": "down",      # Emacs
+                         "ctrl p": "up",        # Emacs
+                         "ctrl v": "page down", # Emacs
+                         "meta v": "page up",   # Emacs
+                         " ": "page down",      # less
+                         "f": "page down",      # less
+                         "b": "page up",        # less
+                         "j": "down",           # vi
+                         "k": "up",             # vi
                          }
         for key in keys:
             try:
@@ -656,66 +655,66 @@
             except KeyError:    # :-)
                 pass
             
-            if key == u"q" or key == u"Q":
+            if key == "q" or key == "Q":
                 self.stop()
                 break
-            elif key == u"window resize":
+            elif key == "window resize":
                 self.size = self.screen.get_cols_rows()
                 self.refresh()
-            elif key == u"\f":  # Ctrl-L
+            elif key == "\f":  # Ctrl-L
                 self.refresh()
-            elif key == u"l" or key == u"D":
+            elif key == "l" or key == "D":
                 self.toggle_log_display()
                 self.refresh()
-            elif key == u"w" or key == u"i":
+            elif key == "w" or key == "i":
                 self.change_log_display()
                 self.refresh()
-            elif key == u"?" or key == u"f1" or key == u"esc":
+            elif key == "?" or key == "f1" or key == "esc":
                 if not self.log_visible:
                     self.log_visible = True
                     self.rebuild()
-                self.log_message_raw((u"bold",
-                                      u"  ".
-                                      join((u"q: Quit",
-                                            u"?: Help",
-                                            u"l: Log window toggle",
-                                            u"TAB: Switch window",
-                                            u"w: Wrap (log)"))))
-                self.log_message_raw((u"bold",
-                                      u"  "
-                                      .join((u"Clients:",
-                                             u"+: Enable",
-                                             u"-: Disable",
-                                             u"R: Remove",
-                                             u"s: Start new checker",
-                                             u"S: Stop checker",
-                                             u"C: Checker OK",
-                                             u"a: Approve",
-                                             u"d: Deny"))))
+                self.log_message_raw(("bold",
+                                      "  ".
+                                      join(("q: Quit",
+                                            "?: Help",
+                                            "l: Log window toggle",
+                                            "TAB: Switch window",
+                                            "w: Wrap (log)"))))
+                self.log_message_raw(("bold",
+                                      "  "
+                                      .join(("Clients:",
+                                             "+: Enable",
+                                             "-: Disable",
+                                             "R: Remove",
+                                             "s: Start new checker",
+                                             "S: Stop checker",
+                                             "C: Checker OK",
+                                             "a: Approve",
+                                             "d: Deny"))))
                 self.refresh()
-            elif key == u"tab":
+            elif key == "tab":
                 if self.topwidget.get_focus() is self.logbox:
                     self.topwidget.set_focus(0)
                 else:
                     self.topwidget.set_focus(self.logbox)
                 self.refresh()
-            #elif (key == u"end" or key == u"meta >" or key == u"G"
-            #      or key == u">"):
+            #elif (key == "end" or key == "meta >" or key == "G"
+            #      or key == ">"):
             #    pass            # xxx end-of-buffer
-            #elif (key == u"home" or key == u"meta <" or key == u"g"
-            #      or key == u"<"):
+            #elif (key == "home" or key == "meta <" or key == "g"
+            #      or key == "<"):
             #    pass            # xxx beginning-of-buffer
-            #elif key == u"ctrl e" or key == u"$":
+            #elif key == "ctrl e" or key == "$":
             #    pass            # xxx move-end-of-line
-            #elif key == u"ctrl a" or key == u"^":
+            #elif key == "ctrl a" or key == "^":
             #    pass            # xxx move-beginning-of-line
-            #elif key == u"ctrl b" or key == u"meta (" or key == u"h":
+            #elif key == "ctrl b" or key == "meta (" or key == "h":
             #    pass            # xxx left
-            #elif key == u"ctrl f" or key == u"meta )" or key == u"l":
+            #elif key == "ctrl f" or key == "meta )" or key == "l":
             #    pass            # xxx right
-            #elif key == u"a":
+            #elif key == "a":
             #    pass            # scroll up log
-            #elif key == u"z":
+            #elif key == "z":
             #    pass            # scroll down log
             elif self.topwidget.selectable():
                 self.topwidget.keypress(self.size, key)

=== modified file 'mandos.lsm'
--- mandos.lsm	2010-10-02 17:23:41 +0000
+++ mandos.lsm	2010-10-11 17:45:21 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.2.1
-Entered-date:	2010-10-02
+Version:	1.2.3
+Entered-date:	2010-10-11
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
 		belorn@fukt.bsnet.se (Björn Påhlsson)
 Primary-site: http://www.fukt.bsnet.se/mandos
-	      130K mandos_1.2.1.orig.tar.gz
+	      133K mandos_1.2.3.orig.tar.gz
 Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		130K mandos_1.2.1.orig.tar.gz
+		133K mandos_1.2.3.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.5, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2010-09-26 18:32:58 +0000
+++ plugins.d/password-prompt.c	2010-11-05 18:30:07 +0000
@@ -22,22 +22,23 @@
  * Contact the authors at <mandos@fukt.bsnet.se>.
  */
 
-#define _GNU_SOURCE		/* getline() */
+#define _GNU_SOURCE		/* getline(), asprintf() */
 
 #include <termios.h> 		/* struct termios, tcsetattr(),
 				   TCSAFLUSH, tcgetattr(), ECHO */
 #include <unistd.h>		/* struct termios, tcsetattr(),
 				   STDIN_FILENO, TCSAFLUSH,
-				   tcgetattr(), ECHO */
+				   tcgetattr(), ECHO, readlink() */
 #include <signal.h>		/* sig_atomic_t, raise(), struct
 				   sigaction, sigemptyset(),
 				   sigaction(), sigaddset(), SIGINT,
 				   SIGQUIT, SIGHUP, SIGTERM,
 				   raise() */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
-#include <sys/types.h>		/* ssize_t */
+#include <sys/types.h>		/* ssize_t, struct dirent, pid_t, ssize_t */
 #include <stdlib.h>		/* EXIT_SUCCESS, EXIT_FAILURE,
-				   getenv() */
+				   getenv(), free() */
+#include <dirent.h>		/* scandir(), alphasort() */
 #include <stdio.h>		/* fprintf(), stderr, getline(),
 				   stdin, feof(), fputc()
 				*/
@@ -47,7 +48,9 @@
 #include <error.h>		/* error() */
 #include <iso646.h>		/* or, not */
 #include <stdbool.h>		/* bool, false, true */
-#include <string.h> 		/* strlen, rindex */
+#include <inttypes.h>		/* strtoumax() */
+#include <sys/stat.h> 		/* struct stat, lstat() */
+#include <string.h> 		/* strlen, rindex, memcmp */
 #include <argp.h>		/* struct argp_option, struct
 				   argp_state, struct argp,
 				   argp_parse(), error_t,
@@ -62,6 +65,10 @@
 const char *argp_program_version = "password-prompt " VERSION;
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
+/* Needed for conflic resolution */
+const char plymouthd_path[] = "/sbin/plymouth";
+
+
 static void termination_handler(int signum){
   if(quit_now){
     return;
@@ -70,6 +77,74 @@
   signal_received = signum;
 }
 
+bool conflict_detection(void){
+
+  /* plymouth conflicts with password-promt since both want to control the
+     associated terminal. Password-prompt exit since plymouth perferms the same
+     functionallity.
+   */
+  int is_plymouth(const struct dirent *proc_entry){
+    int ret;
+    {
+      uintmax_t maxvalue;
+      char *tmp;
+      errno = 0;
+      maxvalue = strtoumax(proc_entry->d_name, &tmp, 10);
+      
+      if(errno != 0 or *tmp != '\0'
+	 or maxvalue != (uintmax_t)((pid_t)maxvalue)){
+	return 0;
+      }
+    }
+    char exe_target[sizeof(plymouthd_path)];
+    char *exe_link;
+    ret = asprintf(&exe_link, "/proc/%s/exe", proc_entry->d_name);
+    if(ret == -1){
+      error(0, errno, "asprintf");
+      return 0;
+    }
+  
+    struct stat exe_stat;
+    ret = lstat(exe_link, &exe_stat);
+    if(ret == -1){
+      free(exe_link);
+      if(errno != ENOENT){
+	error(0, errno, "lstat");
+      }
+      return 0;
+    }
+  
+    if(not S_ISLNK(exe_stat.st_mode)
+       or exe_stat.st_uid != 0
+       or exe_stat.st_gid != 0){
+      free(exe_link);
+      return 0;
+    }
+  
+    ssize_t sret = readlink(exe_link, exe_target, sizeof(exe_target));
+    free(exe_link);
+    if((sret != (ssize_t)sizeof(plymouthd_path)-1) or
+       (memcmp(plymouthd_path, exe_target,
+	       sizeof(plymouthd_path)-1) != 0)){
+      return 0;
+    }
+    return 1;
+  }
+
+  struct dirent **direntries;
+  int ret;
+  ret = scandir("/proc", &direntries, is_plymouth, alphasort);
+  if (ret == -1){
+    error(1, errno, "scandir");
+  }
+  if (ret < 0){
+    return 1;
+  } else {
+    return 0;
+  }
+}
+
+
 int main(int argc, char **argv){
   ssize_t sret;
   int ret;
@@ -151,6 +226,14 @@
   if(debug){
     fprintf(stderr, "Starting %s\n", argv[0]);
   }
+
+  if (conflict_detection()){
+    if(debug){
+      fprintf(stderr, "Stopping %s because of conflict", argv[0]);
+    }
+    return EXIT_FAILURE;
+  }
+  
   if(debug){
     fprintf(stderr, "Storing current terminal attributes\n");
   }

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2010-09-26 18:32:58 +0000
+++ plugins.d/plymouth.c	2010-11-16 18:10:22 +0000
@@ -1,6 +1,6 @@
 /*  -*- coding: utf-8 -*- */
 /*
- * Usplash - Read a password from usplash and output it
+ * Plymouth - Read a password from Plymouth and output it
  * 
  * Copyright © 2010 Teddy Hogeborn
  * Copyright © 2010 Björn Påhlsson
@@ -76,21 +76,23 @@
   char *prompt;
   const char *const cryptsource = getenv("cryptsource");
   const char *const crypttarget = getenv("crypttarget");
-  const char prompt_start[] = "Enter passphrase to unlock the disk";
+  const char prompt_start[] = "Unlocking the disk";
+  const char prompt_end[] = "Enter passphrase";
   
   if(cryptsource == NULL){
     if(crypttarget == NULL){
-      ret = asprintf(&prompt, "%s: ", prompt_start);
+      ret = asprintf(&prompt, "%s\n%s", prompt_start, prompt_end);
     } else {
-      ret = asprintf(&prompt, "%s (%s): ", prompt_start,
-		     crypttarget);
+      ret = asprintf(&prompt, "%s (%s)\n%s", prompt_start,
+		     crypttarget, prompt_end);
     }
   } else {
     if(crypttarget == NULL){
-      ret = asprintf(&prompt, "%s %s: ", prompt_start, cryptsource);
+      ret = asprintf(&prompt, "%s %s\n%s", prompt_start, cryptsource,
+		     prompt_end);
     } else {
-      ret = asprintf(&prompt, "%s %s (%s): ", prompt_start,
-		     cryptsource, crypttarget);
+      ret = asprintf(&prompt, "%s %s (%s)\n%s", prompt_start,
+		     cryptsource, crypttarget, prompt_end);
     }
   }
   if(ret == -1){
@@ -142,21 +144,21 @@
 	_exit(EX_OSERR);
       }
     }
-
+    
     char **new_argv = NULL;
-    char *tmp;
+    char **tmp;
     int i = 0;
-    for (; argv[i]!=(char *)NULL; i++){
+    for (; argv[i]!=NULL; i++){
       tmp = realloc(new_argv, sizeof(const char *) * ((size_t)i + 1));
       if (tmp == NULL){
 	error(0, errno, "realloc");
 	free(new_argv);
 	_exit(EX_OSERR);
       }
-      new_argv = (char **)tmp;
+      new_argv = tmp;
       new_argv[i] = strdup(argv[i]);
     }
-    new_argv[i] = (char *) NULL;
+    new_argv[i] = NULL;
     
     execv(path, (char *const *)new_argv);
     error(0, errno, "execv");
@@ -196,7 +198,7 @@
       return 0;
     }
   }
-  char exe_target[sizeof(plymouth_path)];
+  char exe_target[sizeof(plymouthd_path)];
   char *exe_link;
   ret = asprintf(&exe_link, "/proc/%s/exe", proc_entry->d_name);
   if(ret == -1){
@@ -223,9 +225,9 @@
   
   ssize_t sret = readlink(exe_link, exe_target, sizeof(exe_target));
   free(exe_link);
-  if((sret != (ssize_t)sizeof(plymouth_path)-1) or
-      (memcmp(plymouth_path, exe_target,
-	      sizeof(plymouth_path)-1) != 0)){
+  if((sret != (ssize_t)sizeof(plymouthd_path)-1) or
+      (memcmp(plymouthd_path, exe_target,
+	      sizeof(plymouthd_path)-1) != 0)){
     return 0;
   }
   return 1;
@@ -245,7 +247,15 @@
   if(maxvalue == 0){
     struct dirent **direntries;
     ret = scandir("/proc", &direntries, is_plymouth, alphasort);
-    sscanf(direntries[0]->d_name, "%" SCNuMAX, &maxvalue);
+    if (ret == -1){
+      error(0, errno, "scandir");
+    }
+    if (ret > 0){
+      ret = sscanf(direntries[0]->d_name, "%" SCNuMAX, &maxvalue);
+      if (ret < 0){
+	error(0, errno, "sscanf");
+      }
+    }
   }
   pid_t pid;
   pid = (pid_t)maxvalue;

